// XMPlay DSP plugin header (c) 2004 Ian Luck
// new plugins can be submitted to plugins@xmplay.com


#ifdef __cplusplus
extern "C" {
#endif

#define XMPDSP_FLAG_MULTI 1 // supports multiple instances

typedef struct {
	HWND xmpwin; // XMPlay window handle (filled by XMPlay)
	DWORD flags; // XMPDSP_FLAG_xxx
	char *name; // plugin name

	void (WINAPI *About)(HWND win); // OPTIONAL
	void *(WINAPI *New)(); // create new plugin instance (return new instance handle)

// the following all apply to a specific instance ("inst")
	void (WINAPI *Free)(void *inst); // free plugin instance

	char *(WINAPI *GetDescription)(void *inst); // get description
	void (WINAPI *Config)(void *inst, HWND win); // present config options to user (OPTIONAL)
	DWORD (WINAPI *GetConfig)(void *inst, void *config); // get config (return size of config data)
	BOOL (WINAPI *SetConfig)(void *inst, void *config); // apply config

	void (WINAPI *NewTrack)(void *inst, char *file); // new track has been opened (OPTIONAL)
	void (WINAPI *SetFormat)(void *inst, DWORD rate, DWORD chans); // set sample format
	void (WINAPI *Reset)(void *inst); // reset DSP after seeking
	DWORD (WINAPI *Process)(void *inst, float *data, DWORD count); // process samples (return number of samples processed)
// The Process function currently must return the same amount of data as it is given - it can't
// shorten/stretch the sound. This restriction may (or may not ;)) be lifted in future.
} XMPDSP;

#ifdef __cplusplus
}
#endif
